Index: /trunk/SophyaProg/PrgMap/Makefile
===================================================================
--- /trunk/SophyaProg/PrgMap/Makefile	(revision 3571)
+++ /trunk/SophyaProg/PrgMap/Makefile	(revision 3572)
@@ -68,4 +68,5 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)skymap.h \
   $(SOPHYAINCP)spherethetaphi.h \
@@ -88,5 +89,5 @@
   $(SOPHYAINCP)samba.h \
   $(SOPHYAINCP)alm.h \
-  $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)stsrand.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)triangmtx.h \
@@ -301,4 +302,5 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)skymap.h \
   $(SOPHYAINCP)spherethetaphi.h \
@@ -321,5 +323,5 @@
   $(SOPHYAINCP)samba.h \
   $(SOPHYAINCP)alm.h \
-  $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)stsrand.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)triangmtx.h \
@@ -379,4 +381,5 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)skymap.h \
   $(SOPHYAINCP)spherethetaphi.h \
@@ -399,5 +402,5 @@
   $(SOPHYAINCP)samba.h \
   $(SOPHYAINCP)alm.h \
-  $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)stsrand.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)triangmtx.h \
Index: /trunk/SophyaProg/PrgMap/smakefile
===================================================================
--- /trunk/SophyaProg/PrgMap/smakefile	(revision 3571)
+++ /trunk/SophyaProg/PrgMap/smakefile	(revision 3572)
@@ -89,5 +89,5 @@
   $(SOPHYAINCP)samba.h \
   $(SOPHYAINCP)alm.h \
-  $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)stsrand.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)triangmtx.h \
@@ -323,5 +323,5 @@
   $(SOPHYAINCP)samba.h \
   $(SOPHYAINCP)alm.h \
-  $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)stsrand.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)triangmtx.h \
@@ -402,5 +402,5 @@
   $(SOPHYAINCP)samba.h \
   $(SOPHYAINCP)alm.h \
-  $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)stsrand.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)triangmtx.h \
Index: /trunk/SophyaProg/PrgUtil/Makefile
===================================================================
--- /trunk/SophyaProg/PrgUtil/Makefile	(revision 3571)
+++ /trunk/SophyaProg/PrgUtil/Makefile	(revision 3572)
@@ -52,4 +52,5 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)sambainit.h \
   $(SOPHYAINCP)skymapinit.h \
Index: /trunk/SophyaProg/PrgUtil/scanfits.cc
===================================================================
--- /trunk/SophyaProg/PrgUtil/scanfits.cc	(revision 3571)
+++ /trunk/SophyaProg/PrgUtil/scanfits.cc	(revision 3572)
@@ -13,6 +13,4 @@
 #include "dvlist.h"
 #include "ntuple.h"
-#include "xntuple.h"
-#include "fitsxntuple.h"
 #include "fitsntuple.h"
 */
Index: /trunk/SophyaProg/Tests/Makefile
===================================================================
--- /trunk/SophyaProg/Tests/Makefile	(revision 3571)
+++ /trunk/SophyaProg/Tests/Makefile	(revision 3572)
@@ -228,4 +228,5 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)array.h \
   $(SOPHYAINCP)tarray.h \
@@ -251,4 +252,5 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)timing.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  arrt.cc
@@ -258,4 +260,5 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)array.h \
   $(SOPHYAINCP)tarray.h \
@@ -281,4 +284,5 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)timing.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  carrt.cc
@@ -287,4 +291,5 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
@@ -312,10 +317,10 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)timing.h \
   $(SOPHYAINCP)intflapack.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  lpk.cc
  
-$(SOPHYAOBJP)obj_fits.o: obj_fits.cc \
-  $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)obj_fits.o: obj_fits.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)histinit.h \
   $(SOPHYAINCP)ntoolsinit.h \
@@ -336,6 +341,7 @@
   $(SOPHYAINCP)ntuple.h \
   $(SOPHYAINCP)ntupintf.h \
-  $(SOPHYAINCP)xntuple.h \
-  $(SOPHYAINCP)fitsxntuple.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)fitsntuple.h \
+  $(SOPHYAINCP)ntuple.h \
   $(SOPHYAINCP)fitsfile.h \
   $(SOPHYAINCP)ndatablock.h \
@@ -344,5 +350,4 @@
   $(SOPHYAINCP)FitsIO/longnam.h \
   $(SOPHYAINCP)fitshandler.h \
-  $(SOPHYAINCP)fitsntuple.h \
   $(SOPHYAINCP)fitstarray.h \
   $(SOPHYAINCP)tarray.h \
@@ -356,5 +361,6 @@
   $(SOPHYAINCP)matharr.h \
   $(SOPHYAINCP)fioarr.h \
-  $(SOPHYAINCP)sopemtx.h
+  $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  obj_fits.cc
  
@@ -363,4 +369,5 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)array.h \
   $(SOPHYAINCP)tarray.h \
@@ -386,4 +393,5 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)ctimer.h \
   $(SOPHYAINCP)timing.h \
@@ -394,4 +402,5 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)zthread.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)pisysdep.h \
@@ -399,4 +408,5 @@
   $(SOPHYAINCP)piapplgen.h \
   $(SOPHYAINCP)pimsghandler.h \
+  $(SOPHYAINCP)pisysdep.h \
   $(SOPHYAINCP)picontainerx.h \
   $(SOPHYAINCP)picontainergen.h \
@@ -404,11 +414,19 @@
   $(SOPHYAINCP)piwdggen.h \
   $(SOPHYAINCP)picolist.h \
+  $(SOPHYAINCP)pipixutils.h \
   $(SOPHYAINCP)pimenubarx.h \
   $(SOPHYAINCP)pimenubargen.h \
   $(SOPHYAINCP)pimenux.h \
   $(SOPHYAINCP)pimenugen.h \
+  $(SOPHYAINCP)piconsenum.h \
+  $(SOPHYAINCP)pimenux.h \
+  $(SOPHYAINCP)pistdwdgx.h \
+  $(SOPHYAINCP)pistdwdggen.h \
+  $(SOPHYAINCP)piwindowx.h \
+  $(SOPHYAINCP)piwindowgen.h \
+  $(SOPHYAINCP)piperiodx.h \
+  $(SOPHYAINCP)periodic.h \
   $(SOPHYAINCP)picons.h \
   $(SOPHYAINCP)pistdwdgx.h \
-  $(SOPHYAINCP)pistdwdggen.h \
   $(SOPHYAINCP)pibwdgx.h \
   $(SOPHYAINCP)pibwdggen.h \
@@ -426,8 +444,4 @@
   $(SOPHYAINCP)psfile.h \
   $(SOPHYAINCP)pigraphps.h \
-  $(SOPHYAINCP)piwindowx.h \
-  $(SOPHYAINCP)piwindowgen.h \
-  $(SOPHYAINCP)piperiodx.h \
-  $(SOPHYAINCP)periodic.h \
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
@@ -454,9 +468,9 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)timing.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  pizthr.cc
  
-$(SOPHYAOBJP)ppftswap.o: ppftswap.cc \
-  $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)ppftswap.o: ppftswap.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)sophyainit.h \
   $(SOPHYAINCP)machdefs.h \
@@ -484,6 +498,9 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)fiondblock.h \
-  $(SOPHYAINCP)tarrinit.h
+  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)tarrinit.h \
+  $(SOPHYAINCP)sophyainit.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  ppftswap.cc
  
@@ -492,4 +509,5 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)array.h \
   $(SOPHYAINCP)tarray.h \
@@ -515,4 +533,5 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)timing.h \
   $(SOPHYAINCP)resusage.h
@@ -538,4 +557,5 @@
   $(SOPHYAINCP)cimage.h \
   $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)fioarr.h \
@@ -616,4 +636,5 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)timing.h \
   $(SOPHYAINCP)cexpre.h \
@@ -665,4 +686,5 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)cxxcmplnk.h \
   $(SOPHYAINCP)pdlmgr.h \
@@ -701,5 +723,7 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)histos2.h \
+  $(SOPHYAINCP)histos.h \
   $(SOPHYAINCP)psighand.h \
+  $(SOPHYAINCP)fmath.h \
   $(SOPHYAINCP)srandgen.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tdcr.cc
@@ -732,5 +756,7 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)pdlmgr.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)timing.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tdynl.cc
@@ -739,4 +765,5 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)matharr.h \
   $(SOPHYAINCP)tarray.h \
@@ -802,4 +829,5 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)fitshdtable.h \
+  $(SOPHYAINCP)datatable.h \
   $(SOPHYAINCP)fitshandler.h \
   $(SOPHYAINCP)fitsinoutfile.h \
@@ -819,5 +847,6 @@
   $(SOPHYAINCP)ppfbinstream.h \
   $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)ppersist.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  thash.cc
  
@@ -850,6 +879,8 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)cimage.h \
   $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)fiondblock.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  timg.cc
@@ -882,4 +913,5 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)matharr.h \
   $(SOPHYAINCP)tarrinit.h \
@@ -900,10 +932,47 @@
   $(SOPHYAINCP)swfitsdtable.h \
   $(SOPHYAINCP)fitsswapper.h \
+  $(SOPHYAINCP)fitsinoutfile.h \
   $(SOPHYAINCP)fitsblkrw.h \
   $(SOPHYAINCP)fitshandler.h \
   $(SOPHYAINCP)fitshdtable.h \
+  $(SOPHYAINCP)datatable.h \
   $(SOPHYAINCP)histinit.h \
-  $(SOPHYAINCP)ntoolsinit.h
+  $(SOPHYAINCP)ntoolsinit.h \
+  $(SOPHYAINCP)tarrinit.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tmtdt.cc
+ 
+$(SOPHYAOBJP)tmtrnd.o: tmtrnd.cc $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)zthread.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)resusage.h \
+  $(SOPHYAINCP)ctimer.h \
+  $(SOPHYAINCP)timing.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)matharr.h \
+  $(SOPHYAINCP)tarrinit.h \
+  $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)stsrand.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tmtrnd.cc
  
 $(SOPHYAOBJP)tmtrnd3.o: tmtrnd3.cc $(SOPHYAINCP)sopnamsp.h \
@@ -931,4 +1000,5 @@
   $(SOPHYAINCP)matharr.h \
   $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
@@ -939,40 +1009,8 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tmtrnd3.cc
  
-$(SOPHYAOBJP)tmtrnd.o: tmtrnd.cc $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)zthread.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)resusage.h \
-  $(SOPHYAINCP)ctimer.h \
-  $(SOPHYAINCP)timing.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tmatrix_tsnl.h \
-  $(SOPHYAINCP)tvector_tsnl.h \
-  $(SOPHYAINCP)fioarr.h \
-  $(SOPHYAINCP)matharr.h \
-  $(SOPHYAINCP)tarrinit.h \
-  $(SOPHYAINCP)sophyainit.h \
+$(SOPHYAOBJP)tmxv.o: tmxv.cc $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)srandgen.h \
-  $(SOPHYAINCP)stsrand.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tmtrnd.cc
- 
-$(SOPHYAOBJP)tmxv.o: tmxv.cc $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
@@ -997,4 +1035,5 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)timing.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tmxv.cc
@@ -1007,4 +1046,5 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)array.h \
   $(SOPHYAINCP)tarray.h \
@@ -1030,10 +1070,13 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)fitsinoutfile.h \
   $(SOPHYAINCP)FitsIO/fitsio.h \
   $(SOPHYAINCP)FitsIO/longnam.h \
   $(SOPHYAINCP)fitsblkrw.h \
+  $(SOPHYAINCP)fitsinoutfile.h \
   $(SOPHYAINCP)fitsarrhand.h \
   $(SOPHYAINCP)fitshandler.h \
+  $(SOPHYAINCP)fitsblkrw.h \
   $(SOPHYAINCP)fiosinit.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tnfits.cc
@@ -1058,5 +1101,5 @@
   $(SOPHYAINCP)ntuple.h \
   $(SOPHYAINCP)ntupintf.h \
-  $(SOPHYAINCP)xntuple.h \
+  $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)datatable.h \
   $(SOPHYAINCP)basedtable.h \
@@ -1077,5 +1120,5 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tnt.cc
  
-$(SOPHYAOBJP)tobjio2.o: tobjio2.cc $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)tobjio.o: tobjio.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)histinit.h \
   $(SOPHYAINCP)ntoolsinit.h \
@@ -1108,10 +1151,13 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)histos2.h \
+  $(SOPHYAINCP)histos.h \
   $(SOPHYAINCP)ntuple.h \
   $(SOPHYAINCP)ntupintf.h \
-  $(SOPHYAINCP)srandgen.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tobjio2.cc
- 
-$(SOPHYAOBJP)tobjio.o: tobjio.cc $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)fmath.h \
+  $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)fioarr.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tobjio.cc
+ 
+$(SOPHYAOBJP)tobjio2.o: tobjio2.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)histinit.h \
   $(SOPHYAINCP)ntoolsinit.h \
@@ -1144,9 +1190,11 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)histos2.h \
+  $(SOPHYAINCP)histos.h \
   $(SOPHYAINCP)ntuple.h \
   $(SOPHYAINCP)ntupintf.h \
-  $(SOPHYAINCP)srandgen.h \
-  $(SOPHYAINCP)fioarr.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tobjio.cc
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)fmath.h \
+  $(SOPHYAINCP)srandgen.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tobjio2.cc
  
 $(SOPHYAOBJP)tpipe.o: tpipe.cc $(SOPHYAINCP)sopnamsp.h \
@@ -1157,6 +1205,5 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tpipe.cc
  
-$(SOPHYAOBJP)tsimplex.o: tsimplex.cc \
-  $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)tsimplex.o: tsimplex.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)simplex.h \
   $(SOPHYAINCP)machdefs.h \
@@ -1193,4 +1240,5 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)timing.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tsimplex.cc
@@ -1206,4 +1254,5 @@
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)timing.h \
+  $(SOPHYAINCP)resusage.h \
   $(SOPHYAINCP)sphereecp.h \
   $(SOPHYAINCP)sphericalmap.h \
@@ -1211,4 +1260,5 @@
   $(SOPHYAINCP)pixelmap.h \
   $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)gnumd5.h \
   $(SOPHYAINCP)ppfbinstream.h \
@@ -1235,11 +1285,13 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)fiosphereecp.h \
+  $(SOPHYAINCP)sphereecp.h \
   $(SOPHYAINCP)array.h \
   $(SOPHYAINCP)matharr.h \
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)samba.h \
   $(SOPHYAINCP)alm.h \
-  $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)stsrand.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)triangmtx.h \
@@ -1257,4 +1309,51 @@
   $(SOPHYAINCP)tod.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tsphereecp.cc
+ 
+$(SOPHYAOBJP)tspm.o: tspm.cc $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)skymapinit.h \
+  $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)skymap.h \
+  $(SOPHYAINCP)spherethetaphi.h \
+  $(SOPHYAINCP)sphericalmap.h \
+  $(SOPHYAINCP)smathconst.h \
+  $(SOPHYAINCP)pixelmap.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)spherepos.h \
+  $(SOPHYAINCP)unitvector.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)longlat.h \
+  $(SOPHYAINCP)utilgeom.h \
+  $(SOPHYAINCP)datatype.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)spherehealpix.h \
+  $(SOPHYAINCP)HEALPixUtils.h \
+  $(SOPHYAINCP)localmap.h \
+  $(SOPHYAINCP)sphereecp.h \
+  $(SOPHYAINCP)fiospherethetaphi.h \
+  $(SOPHYAINCP)fiospherehealpix.h \
+  $(SOPHYAINCP)fiolocalmap.h \
+  $(SOPHYAINCP)fiosphereecp.h \
+  $(SOPHYAINCP)tod.h \
+  $(SOPHYAINCP)misstime.h \
+  $(SOPHYAINCP)timing.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tspm.cc
  
 $(SOPHYAOBJP)tspm2.o: tspm2.cc $(SOPHYAINCP)sopnamsp.h \
@@ -1316,55 +1415,9 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tspm2.cc
  
-$(SOPHYAOBJP)tspm.o: tspm.cc $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)skymapinit.h \
-  $(SOPHYAINCP)sophyainit.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)skymap.h \
-  $(SOPHYAINCP)spherethetaphi.h \
-  $(SOPHYAINCP)sphericalmap.h \
-  $(SOPHYAINCP)smathconst.h \
-  $(SOPHYAINCP)pixelmap.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)spherepos.h \
-  $(SOPHYAINCP)unitvector.h \
-  $(SOPHYAINCP)vector3d.h \
-  $(SOPHYAINCP)longlat.h \
-  $(SOPHYAINCP)utilgeom.h \
-  $(SOPHYAINCP)datatype.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tmatrix_tsnl.h \
-  $(SOPHYAINCP)tvector_tsnl.h \
-  $(SOPHYAINCP)spherehealpix.h \
-  $(SOPHYAINCP)HEALPixUtils.h \
-  $(SOPHYAINCP)localmap.h \
-  $(SOPHYAINCP)sphereecp.h \
-  $(SOPHYAINCP)fiospherethetaphi.h \
-  $(SOPHYAINCP)fiospherehealpix.h \
-  $(SOPHYAINCP)fiolocalmap.h \
-  $(SOPHYAINCP)fiosphereecp.h \
-  $(SOPHYAINCP)tod.h \
-  $(SOPHYAINCP)misstime.h \
-  $(SOPHYAINCP)timing.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tspm.cc
- 
 $(SOPHYAOBJP)tstboloread.o: tstboloread.cc \
   $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)fboloread.h \
@@ -1378,4 +1431,5 @@
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)gnumd5.h \
   $(SOPHYAINCP)ppfbinstream.h \
@@ -1397,4 +1451,5 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)fabtcolread.h \
@@ -1408,4 +1463,5 @@
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)gnumd5.h \
   $(SOPHYAINCP)ppfbinstream.h \
@@ -1422,6 +1478,5 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tstcolread.cc
  
-$(SOPHYAOBJP)tstdtable.o: tstdtable.cc \
-  $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)tstdtable.o: tstdtable.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)histinit.h \
   $(SOPHYAINCP)ntoolsinit.h \
@@ -1460,10 +1515,10 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tstdtable.cc
  
-$(SOPHYAOBJP)tstndblk.o: tstndblk.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)ntoolsinit.h \
-  $(SOPHYAINCP)tarrinit.h \
-  $(SOPHYAINCP)sophyainit.h \
+$(SOPHYAOBJP)tstndblk.o: tstndblk.cc $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)ntoolsinit.h \
+  $(SOPHYAINCP)tarrinit.h \
+  $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)ndatablock.h \
@@ -1479,8 +1534,10 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)ppfwrapstlv.h \
   $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)gnumd5.h \
   $(SOPHYAINCP)ppfbinstream.h \
@@ -1489,6 +1546,5 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tstppfwrapstl.cc
  
-$(SOPHYAOBJP)tstsegdb.o: tstsegdb.cc \
-  $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)tstsegdb.o: tstsegdb.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)timing.h \
@@ -1497,8 +1553,10 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)segdatablock.h \
   $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)thsafeop.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)fiosegdb.h \
   $(SOPHYAINCP)ppersist.h \
@@ -1507,7 +1565,9 @@
   $(SOPHYAINCP)rawstream.h \
   $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)segdatablock.h \
   $(SOPHYAINCP)ppftpointerio.h \
   $(SOPHYAINCP)swsegdb.h \
   $(SOPHYAINCP)ppfswapper.h \
+  $(SOPHYAINCP)swsegdb.h \
   $(SOPHYAINCP)ppfwrapstlv.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tstsegdb.cc
@@ -1518,4 +1578,5 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)array.h \
@@ -1527,4 +1588,5 @@
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)gnumd5.h \
   $(SOPHYAINCP)ppfbinstream.h \
@@ -1541,9 +1603,9 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)srandgen.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tsttmat.cc
  
-$(SOPHYAOBJP)tsttminv.o: tsttminv.cc \
-  $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)tsttminv.o: tsttminv.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)timing.h \
@@ -1551,4 +1613,5 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)array.h \
@@ -1560,4 +1623,5 @@
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)gnumd5.h \
   $(SOPHYAINCP)ppfbinstream.h \
@@ -1574,4 +1638,5 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)srandgen.h \
   $(SOPHYAINCP)intflapack.h
@@ -1583,4 +1648,5 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)array.h \
@@ -1592,4 +1658,5 @@
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)gnumd5.h \
   $(SOPHYAINCP)ppfbinstream.h \
@@ -1606,4 +1673,5 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)srandgen.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tsttvec.cc
@@ -1631,4 +1699,5 @@
   $(SOPHYAINCP)thsafeop.h \
   $(SOPHYAINCP)fitsinoutfile.h \
+  $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)FitsIO/fitsio.h \
   $(SOPHYAINCP)FitsIO/longnam.h \
@@ -1646,7 +1715,9 @@
   $(SOPHYAINCP)fiosinit.h \
   $(SOPHYAINCP)swfitsdtable.h \
+  $(SOPHYAINCP)fitsswapper.h \
   $(SOPHYAINCP)fitshandler.h \
   $(SOPHYAINCP)datatable.h \
-  $(SOPHYAINCP)fitshdtable.h
+  $(SOPHYAINCP)fitshdtable.h \
+  $(SOPHYAINCP)datatable.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tswfits.cc
  
@@ -1656,4 +1727,5 @@
   $(SOPHYAINCP)timing.h \
   $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)anydataobj.h \
@@ -1668,4 +1740,5 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)ppfwrapstlv.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  ttimestamp.cc
@@ -1693,8 +1766,10 @@
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tvector_tsnl.h \
-  $(SOPHYAINCP)matharr.h \
-  $(SOPHYAINCP)tarrinit.h \
-  $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)matharr.h \
+  $(SOPHYAINCP)tarrinit.h \
+  $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)stsrand.h \
   $(SOPHYAINCP)timing.h \
   $(SOPHYAINCP)ctimer.h
Index: /trunk/SophyaProg/Tests/obj_fits.cc
===================================================================
--- /trunk/SophyaProg/Tests/obj_fits.cc	(revision 3571)
+++ /trunk/SophyaProg/Tests/obj_fits.cc	(revision 3572)
@@ -8,6 +8,4 @@
 #include "dvlist.h"
 #include "ntuple.h"
-#include "xntuple.h"
-#include "fitsxntuple.h"
 #include "fitsntuple.h"
 #include "fitstarray.h"
@@ -60,5 +58,5 @@
       
       cout << " Creating NTuple " << endl;
-      char * names[3] = {"XPos", "YPos", "Val"};
+      const char * names[3] = {"XPos", "YPos", "Val"};
       int i,j, k;
       float xnt[3];
